PROGRAM Taschenrechner
  IMPLICIT NONE

	REAL:: x,y
	CHARACTER:: Operation
	
	DO
	
		WRITE(*,*) 'Gib eine Operation an'
		WRITE(*,*) 'Schreibe + (Addition), - (Subtraktion), % (Division), * (Multiplikation) oder k (Kreisfläche)'
		READ(*,*) Operation
	
		SELECT CASE (Operation)
			CASE('+')
					WRITE(*,*) 'Gib zwei Summanden ein'
					READ(*,*) x,y
					WRITE(*,*) x, ' + ', y, ' = ', x+y
			CASE('-')
					WRITE(*,*) 'Gib Minuend und Subtrahend ein'
					READ(*,*) x,y
					WRITE(*,*) x, ' - ', y, ' = ',x-y
		
			CASE('*')
					WRITE(*,*) 'Gib zwei Faktoren ein'
					READ(*,*) x,y
					WRITE(*,*) x, ' * ', y, ' = ', x*y
			CASE('%')
					WRITE(*,*) 'Gib Dividend und Divisor ein'
					READ(*,*) x,y
					IF (y==0) THEN
				 		WRITE(*,*) 'Teilung durch 0 ist verboten!'
					ELSE
						WRITE(*,*) x, ' / ', y, ' = ', x/y
					END IF
			CASE('k')
					WRITE(*,*) 'Gib einen Radius ein!'
					READ(*,*) x
					IF (x<0) THEN
				 		WRITE(*,*) 'Der Radius soll positiv sein!'
					ELSE
						write(*,*) 'Die Flaeche betraegt ', area(x)
					END IF
			CASE DEFAULT
					WRITE(*,*) 'Ungültige Eingabe!'
					EXIT
		END SELECT
		
	END DO

CONTAINS

  FUNCTION area (radius)
    REAL :: area, radius
    REAL, PARAMETER :: pi = 3.14159

    area = pi * radius**2

  END FUNCTION

END PROGRAM
