PROGRAM sudoku
  IMPLICIT NONE

  INTEGER, DIMENSION(:,:), ALLOCATABLE :: S
  INTEGER(kind = 1) :: i
  INTEGER :: n, dim
  
  DO
    WRITE(*,*) 'Bitte die Groesse des Sudokus eingeben (n)'
    READ(*,*) n
    IF (n < 2) EXIT
    
    dim = n**2
    
    ALLOCATE(S(dim, dim))
    
    ! Sudoku zeilenweise einlesen
    DO i = 1, dim
      WRITE(*,*) 'Bitte Zeile ', i, ' eingeben:' 
      READ(*,*) S(i, :)
    END DO
    
    
    ! DODO: Test, ob in jeder Zeile jede Zahl von 1 bis n^2 (=dim) vorkommt
    
    ! DODO: Test, ob in jeder Spalte jede Zahl von 1 bis n^2 (=dim) vorkommt
    
    ! Zusatz: Test, ob in jedem n x n - Block jede Zahl von 1 bis n^2 (=dim) vorkommt
    
    
    ! Sudoku zeilenweise ausgeben
    DO i = 1, dim
      WRITE(*,*) S(i, :)
    END DO
    
    DEALLOCATE(S)
  END DO
  
END PROGRAM
