PROGRAM Zahlentripel
  IMPLICIT NONE 
  
  INTEGER :: i,j,z,k
  REAL::start,ende
  
  !einfache Variante 
  
  k=0
  
  CALL CPU_TIME(start)
  
  DO i=0,50
    DO j=0,50 
	  DO z=0,50
	    IF(i+j+z==50) THEN 
		  WRITE(*,*) '(',i,',',j,',',z,')'
		  k=k+1
		END IF 
	  END DO 
	END DO 
  END DO 
  
  CALL CPU_TIME(ende)
  
  WRITE(*,*) 'Anzahl Tripel: ',k
  WRITE(*,*) 'Benötigte Zeit: ', ende-start,' Sekunden'
  
  WRITE(*,*) '---------------------------------------------------------'
  
  !Andere Variante 
  
  k=0
  
  CALL CPU_TIME(start)
  
  DO i=0,50,1
    DO j=i, (50-i)/2,1
	  WRITE(*,*) '(',i,',',j,',',50-i-j,')'
	  k=k+1
	END DO 
  END DO 
  
  CALL CPU_TIME(ende)
  
  WRITE(*,*) 'Anzahl Tripel: ',k
  WRITE(*,*) 'Benötigte Zeit: ', ende-start,' Sekunden'
  
  WRITE(*,*) '---------------------------------------------------------'
  
  !auch möglich: 
  
  k=0 
  
  CALL CPU_TIME(start)
  
  DO i = 0, 50
    DO j = i, 50-i
      z = 50 - (i+j)
      IF (j <= z) then
        WRITE(*,*) i, ' + ', j, ' + ', z, ' = 50'
		k=k+1
        cycle
      END IF
    END DO
  END DO
  
  CALL CPU_TIME(ende)
  
  WRITE(*,*) 'Anzahl Tripel: ',k
  WRITE(*,*) 'Benötigte Zeit: ', ende-start,' Sekunden'
  
  WRITE(*,*) '---------------------------------------------------------'
 
  
  !alle vierstelligen Zahlen mit 1,2,3,4 
  
  DO i=1,4
    DO j=1,4
	  DO k=1,4
	    DO z=1,4 
		  WRITE(*,*) i*1000 + j*100 + k*10 + z
		  !WRITE(*,*) ((((i*10)+j)*10)+k)*10+m
		END DO 
	  END DO 
	END DO 
  END DO 
  
END PROGRAM 