PROGRAM VierQuad
	IMPLICIT NONE 

    INTEGER:: zahl, i
	
	WRITE(*,*) 'Welche Zahl möchtest du prüfen?'
	READ(*,*) zahl 
	
	CALL VierQuadrate(zahl) 

    DO i=0,100
        !CALL VierQuadrate(i)
        IF(.NOT. VierQuadrate2(i))THEN
            WRITE(*,*) 'Für folgende Zahl hat es nicht geklappt: ', i
            EXIT
        END IF
    END DO
	
	DO i=0,100
		IF(.NOT. dreiQuadrate(i)) THEN !Ausgabe aller Zahlen von 1 bis 100, die nicht 
			!als Summe von drei Quadratzahlen darstellbar sind 
			WRITE(*,*) 'Keine Summe aus drei Quadraten für: ', i 
		END IF 
	END DO 

CONTAINS

	    SUBROUTINE VierQuadrate(x)
            INTEGER:: x
            INTEGER:: q1, q2, q3, q4
            INTEGER:: w 
			
			w = SQRT(REAL(x))

            outer: DO q1 = 0, w
                DO q2 = 0, w
                    DO q3 = 0, w 
                        DO q4 = 0, w
                            IF (x == q1 ** 2 + q2 ** 2 + q3 ** 2 + q4**2) THEN
                                WRITE(*,*) x, ":", q1,q2,q3,q4
                                EXIT outer
                            END IF
                        END DO 
                    END DO
                END DO 
            END DO outer

	    END SUBROUTINE VierQuadrate

	    !FUNCTION VierQuadrate2(x)
        LOGICAL FUNCTION VierQuadrate2(x)
		
            INTEGER:: x
            !LOGICAL :: VierQuadrate2
            INTEGER:: q1, q2, q3, q4
            INTEGER:: w 
			
			w = SQRT(REAL(x))
            VierQuadrate2 = .false.

            outer: DO q1 = 0, w
                DO q2 = 0, w
                    DO q3 = 0, w 
                        DO q4 = 0, w
                            IF (x == q1 ** 2 + q2 ** 2 + q3 ** 2 + q4**2) THEN
                                WRITE(*,*) x, ":", q1,q2,q3,q4
                                VierQuadrate2 = .true.
                                EXIT outer
                            END IF
                        END DO 
                    END DO
                END DO 
            END DO outer

	    END FUNCTION VierQuadrate2
		
		
        FUNCTION dreiQuadrate(x)
		
            INTEGER:: x
            LOGICAL :: dreiQuadrate
            INTEGER:: q1, q2, q3
            INTEGER:: w 
			
			w = SQRT(REAL(x))
            dreiQuadrate = .false.

            outer: DO q1 = 0, w
                DO q2 = 0, w
                    DO q3 = 0, w 
                       ! DO q4 = 0, w
                            IF (x == q1 ** 2 + q2 ** 2 + q3 ** 2 ) THEN
                                WRITE(*,*) x, ":", q1,q2,q3
                                dreiQuadrate = .true.
                                EXIT outer
                            END IF
                        !END DO 
                    END DO
                END DO 
            END DO outer

	    END FUNCTION dreiQuadrate
		

END PROGRAM VierQuad
