








program wetterstation
    implicit none

    integer, dimension(14) :: temperatur
    integer :: temp_min, temp_max, temp_av

    integer, dimension(13) :: temp_umschwung ! tag mit dem groessten temperaturumschwung und der tempumschwung
    integer :: i, temp_umschw_max

    temperatur = (/12,14,9,12,15,16,15,15,11,8,14,13,15,12/)

    temp_min = minloc(temperatur, 1)
    temp_max = maxloc(temperatur, 1)
    temp_av = sum(temperatur) / 14

    ! berechne tabelle mit allen temperaturumschwungen von tag i auf i+1
    do i = 1, 13
        temp_umschwung(i) = abs( temperatur(i) - temperatur(i+1) )
    end do
    temp_umschw_max = maxloc(temp_umschwung, 1)


    ! AUSGABE
    do i = 1, 14 ! Vertikale Tabelle
        write(*,*) i, temperatur(i)
    end do 

    write(*,*) "Die minimalste Temperatur war an Tag ", temp_min, " mit ", temperatur(temp_min), " Grad."
    write(*,*) "Die hoechste Temperatur war an Tag ", temp_max, " mit ", temperatur(temp_max), " Grad."
    write(*,*) "Die Durchschnittstemperatur ist ", temp_av, " Grad."

    write(*,*) "Der groesste Temperaturumschwung war von Tag", temp_umschw_max, " zu ", temp_umschw_max+1," mit ",&
        &temp_umschwung(temp_umschw_max), " Grad."
    
end program wetterstation